clear all;
close all;

w=what('F:\AMMA_2007\RHB\Aerosol\Raw\');

year=2007;
month=05;


a=dir([w.path '0705*.csv']);

jd=[];

c0=[];c1=[];c2=[];c3=[];c4=[];c5=[];fl=[];

for i=1:length(a)
	a(i).name
	day=str2num(a(i).name(5:6));
	chnl0=[];chnl1=[];chnl2=[];chnl3=[];chnl4=[];chnl5=[];flow_rate=[];
	temp=importdata([w.path a(i).name],',');
	time1=[];
	for j=2:length(temp.textdata)

		dummy=temp.textdata(j,2);

		dummy=dummy{1};
		
		hour=str2num(dummy(2:3));
		minute=str2num(dummy(5:6));

		sec=str2num(dummy(8:9));
		
		time1=[time1 hour*3600+minute*60+sec];
		clear minute sec dummy;
	end
	flow_rate=vertcat(flow_rate,temp.data(:,1));
	chnl0=vertcat(chnl0,temp.data(:,4));
	chnl1=vertcat(chnl1,temp.data(:,6));
	chnl2=vertcat(chnl2,temp.data(:,8));
	chnl3=vertcat(chnl3,temp.data(:,10));
	chnl4=vertcat(chnl4,temp.data(:,12));
	chnl5=vertcat(chnl5,temp.data(:,14));

	clear temp;

	for j=hour*3600+600:600:(hour+1)*3600
		g=find(time1>j-600 & time1<j);
		if length(g)>0
		c0=[c0 nanmean(chnl0(g))];
		c1=[c1 nanmean(chnl1(g))];
		c2=[c2 nanmean(chnl2(g))];
		c3=[c3 nanmean(chnl3(g))];
		c4=[c4 nanmean(chnl4(g))];
		c5=[c5 nanmean(chnl5(g))];
		fl=[fl nanmean(flow_rate(g))];        
		jd=[jd datenum(2007,05,day)-datenum(2006,12,31)+time1(g(1))/86400];
		clear g;
		end
	end

	clear chnl* hour;

end


figure(1)
set(gcf,'defaultaxesfonts',18)
set(gca,'fontname','time','fontsize',18);
%subplot(2,1,1)
semilogy(jd,c0,'b.')
hold on
semilogy(jd,c1,'r.')
semilogy(jd,c2,'g.')
semilogy(jd,c3,'y.')
semilogy(jd,c4,'c.')
semilogy(jd,c5,'k.')
h=legend('0.1 \mum','0.2 \mum','0.3 \mum','0.5 \mum','1 \mum','5 \mum','location','northwest');
set(h,'fontsize',6)
ylabel('No of Particles (m^{-3})');
xlabel('Julian Day 2007')
%ylim([10^0 10^6])
title('AMMA 2007 PMS 10 min data')
print_buffer=['-djpeg90 F:\AMMA_2007\RHB\Aerosol\Raw_Images\pms_AMMA_07np.jpg']
eval(['print ' print_buffer]);
xlim([123 134])
%set(gca,'xtick',[0:4:24]);

figure(2)
%subplot(2,1,2)
semilogy(jd,c0+c1+c2+c3+c4+c5,'k.');
ylabel('No of Particles (m^{-3})');
xlabel('Julian Day 2007')
title('AMMA 2007 Total No of particles')
%xlim([286 299])
%set(gca,'xtick',[0:4:24])

print_buffer=['-djpeg90 F:\AMMA_2007\RHB\Aerosol\Raw_Images\pms_AMMA_07tnp.jpg']
eval(['print ' print_buffer]);

Ntotal=c0+c1+c2+c3+c4+c5;
stux_all=[jd' Ntotal' c0' c1' c2' c3' c4' c5'];
y=stux_all;
jdav=[];yav=[];yvar=[];
[jdav,yav,yvar]=timave_2_nonan(jd,10,y);
[jdhr,yhr,yvarr]=timave_2_nonan(jd,60,y);

save F:\AMMA_2007\RHB\Aerosol\Raw\PMS_10mn_AMMA_07.txt yav -ascii -tabs;

figure(3)
semilogy(jdav,yav(:,3)*10,'.',jdav,yav(:,4)*10,'.',jdav,yav(:,5)*10,'.',jdav,yav(:,6)*10,'.',jdav,yav(:,7)*10,'y.',jdav,yav(:,8)*10,'k.');
set(gca,'fontsize',14);
ylabel('Cts in Channel');
xlabel('Julian Day (2007)');
title('AMMA 2007 PMS');
print_buffer=['-djpeg90 F:\AMMA_2007\RHB\Aerosol\Raw_Images\pms_AMMA_07tcts.jpg']
eval(['print ' print_buffer]);

dt=median(diff(time1))/60;%time interval in min
flow=2.829e4;%flow rate, cc/min
vol=flow*dt;
std=jd(1);ent=jd(length(jd));

figure(4)
subplot(2,1,1);semilogy(jdav,yav(:,2)*10/vol,'.');
set(gca,'fontsize',12);
ylabel('Total Conc. (#/cm^3)');
title('AMMA 2007 PMS');
%axis([std ent 10 1e3]);
subplot(2,1,2);semilogy(jdav,yav(:,3)*10/vol,'.',jdav,yav(:,4)*10/vol,'.',jdav,yav(:,5)*10/vol,'.',jdav,yav(:,6)*10/vol,'.',jdav,yav(:,7)*10/vol,'.',jdav,yav(:,8)*10/vol,'.');
set(gca,'fontsize',12);
ylabel('Conc. in Channel (#/cm^3)');
xlabel('Julian Day (2007)');
print_buffer=['-djpeg90 F:\AMMA_2007\RHB\Aerosol\Raw_Images\pms_AMMA_07tconc.jpg']
eval(['print ' print_buffer]);
%axis([std ent .10 1e3]);

save d:\RHB_AMMA07_process_progs\PMS\PSD_PMS  jd c1 c2 c3 c4 c5 fl

figure
plot(jd,fl)
title('AMMA07  flow=2.829e4')
xlabel('Julian Day (UTC)')
ylabel('Flow Rate (cc/min)')
print_buffer=['-djpeg90 F:\AMMA_2007\RHB\Aerosol\Raw_Images\pms_AMMA_07tflow.jpg']
eval(['print ' print_buffer]);


