disp('read_motion_07.m')

if hhh<10,
   dfx2=['0',num2str(hhh)];
else
   dfx2=num2str(hhh);
end;

if ddd<10,
   dfx1=['00',num2str(ddd)];
elseif ddd<100,
   dfx1=['0',num2str(ddd)];
else
   dfx1=num2str(ddd);
end;


dfx=[dfx1 dfx2];

dfl=[way_raw_data,'day',dfx(1:3),'\P5_',dfx];
disp(dfl)
flist=fopen(dfl,'r');         %disp(dfl)
if flist>0
    headr=fgetl(flist);           %disp(headr)
    headr=fgetl(flist);
    z=fscanf(flist,'%g,%g,%g,%g,%g,%g,%g',[7,inf]);
else
    disp('file not found')
end;

tm1=z(1,:);
tmotion=tm1;
 if clearit;clear tm1;end;
tmotion=tmotion-tmotion(1);
tmotion=0:1/20:(length(tmotion)-1)/20;
tmotion=tmotion';

%  As mounted:  motion-pak
%  Xm is toward port
%  Ym is toward bow
%  Zm is down

%  We desire the coordinate system such that
%  +X is toward bow
%  +Y is toward port
%  +Z is up
%  +rotation about the x-axis is port up (phi = roll) 
%  +rotation about the y-axis is bow down (theta = pitch)
%  +rotation about the z-axis is bow to port

accx=+z(6,:)./3.75.*9.81;               %forward is positive 
accy=+(z(5,:)-.1)./3.75.*9.81;          %to port is positive
accz=-z(7,:)./3.756.*9.81;              %up is positive

ratex=+z(3,:)/0.025/180*pi;          %port up is positive phi
ratey=+z(2,:)/0.025/180*pi;          %bow down is positive theta
ratez=-z(4,:)/0.025023/180*pi;       %bow to port is positive psi (right-handed)

% figure;
% subplot(3,2,1);plot(accx);title('accx');
% subplot(3,2,2);plot(accy);title('accy');
% subplot(3,2,3);plot(accz);title('accz'); 
% subplot(3,2,4);plot(ratex);title('ratex');
% subplot(3,2,5);plot(ratey);title('ratey');
% subplot(3,2,6);plot(ratez);title('ratez');

accx=accx.*1.017;
accy=accy.*1.017;
accz=accz.*1.017;

G=sqrt(mean(accx)^2+mean(accy)^2+mean(accz)^2);

accx=accx';
accy=accy';
ratex=ratex';
ratey=ratey';
ratez=ratez';
tmotion=tmotion';

%IFM_CO2=z(7,:);
%IFM_H2O=z(8,:);

%if length(IFM_CO2)<72000,
%   IFM_CO2=[IFM_CO2 (1:72000-length(IFM_CO2)).*0+IFM_CO2(length(IFM_CO2))];
%   IFM_H2O=[IFM_H2O (1:72000-length(IFM_H2O)).*0+IFM_H2O(length(IFM_H2O))];
%end;

%IFM_CO2=IFM_CO2*0.1829;     %convert from volts to g/m3
%IFM_H2O=IFM_H2O.*5;         %convert from volts to g/m3

%if ddd+hhh/24 < 44.625,
%   A_ifm=0.90;
%   B_ifm=0.47;
%elseif ddd+hhh/24 >= 44.625 & ddd+hhh/24 < 46.458,
%   A_ifm=1.00;
%   B_ifm=0.60;
%elseif ddd+hhh/24 >= 46.458 & ddd+hhh/24 < 61.901,
%   A_ifm=1.00;
%   B_ifm=0.65;
%elseif ddd+hhh/24 >= 61.901,
%   A_ifm=1.00;
%   B_ifm=0.60;
%end;

ycheck=find(accz>50);

for mm=length(accz):-1:1;
   if accz(mm)>50,
      accz(mm)=0;
   else;
      break;
   end;
end;

for mm=1:1:length(accz);
   if accz(mm)>50,
      accz(mm)=0;
   else;
      break;
   end;
end;

ycheck=find(accz>50);

if ~isempty(ycheck),
   xcheck=ycheck(1:length(ycheck)-1).*0;
   for iii=2:length(ycheck);
      xcheck(iii-1)=ycheck(iii)-ycheck(iii-1);
   end;
   for iii=1:length(xcheck);
      if xcheck(iii)==2,
         ycheck=[ycheck(1:iii) ycheck(iii)+1 ycheck(iii+1:length(ycheck))];
         xcheck=[xcheck(1:iii-1) 1 1 xcheck(iii+1:length(xcheck))];
      end;
   end;
      
   wcheck=find(xcheck>1);
   wcheck=[0 wcheck];
   if wcheck==0,
      wcheck=[0 length(ycheck)];
   end;

   par=zeros(1,length(wcheck));
   
   if length(wcheck)>2,
      if ycheck(1) > 20 & ycheck(wcheck(2)+1) - ycheck(wcheck(2)) > 20,
         par(1)=20;
      else;
         par(1)=min(ycheck(1),ycheck(wcheck(2)+1)-ycheck(wcheck(2)))-1;
         if par(1)==0 | par(1)==1,
            par(1)=2;
         end;
      end;
   
      for ii=2:length(wcheck)-1,
         if ycheck(wcheck(ii)+1)-ycheck(wcheck(ii)) > 20 & ycheck(wcheck(ii+1)+1) - ycheck(wcheck(ii+1)) > 20,
            par(ii)=20;
         else;
            par(ii)=min(ycheck(wcheck(ii)+1)-ycheck(wcheck(ii)),ycheck(wcheck(ii+1)+1)-ycheck(wcheck(ii+1)))-1;
            if par(ii)==0 | par(ii)==1,
               par(ii)=2;
            end;
         end;
      %disp([num2str(ii),'  ',num2str(par(ii))])
      end;

      if ycheck(wcheck(length(wcheck))+1) - ycheck(wcheck(length(wcheck))) > 20 & length(accz) - ycheck(length(ycheck)) > 20,
         par(length(wcheck))=20;
      else;
         par(length(wcheck))=min(ycheck(wcheck(length(wcheck))+1) - ycheck(wcheck(length(wcheck))),length(accz) - ycheck(length(ycheck)))-1;
         if par(length(par))==0 | par(length(par))==1,
            par(length(par))=2;
         end;
      %disp([num2str(length(par)),'  ',num2str(par(length(par)))])
      end;
      
   elseif length(wcheck)==2,
      if length(ycheck)==wcheck(2),
         if ycheck(1) > 20 & length(accz) - ycheck(length(ycheck)) > 20,
            par(1)=20;
         else;
            par(1)=min(ycheck(1),length(accz) - ycheck(length(ycheck)))-1;
            if par(1)==0 | par(1)==1,
               par(1)=2;
            end;
         end;
      else,
         if ycheck(1) > 20 & ycheck(wcheck(2)+1) - ycheck(wcheck(2)) > 20,
            par(1)=20;
         else;
            par(1)=min(ycheck(1),ycheck(wcheck(2)+1)-ycheck(wcheck(2)))-1;
            if par(1)==0 | par(1)==1,
               par(1)=2;
            end;
         end;
         if ycheck(wcheck(2)+1) - ycheck(wcheck(2)) > 20 & length(accz)-ycheck(length(ycheck)) > 20,
            par(2)=20;
         else;
            par(2)=min(ycheck(wcheck(2)+1)-ycheck(wcheck(2)),length(accz)-ycheck(length(ycheck)))-1;
            if par(2)==0 | par(2)==1,
               par(2)=2;
            end;
         end;
      end;
   end;
   
   for ii=1:length(wcheck)-1,
      vcheck=[accz(ycheck(wcheck(ii)+1)-par(ii):ycheck(wcheck(ii)+1)-1) accz(ycheck(wcheck(ii+1))+1:ycheck(wcheck(ii+1))+par(ii))];
      ucheck=[tmotion(ycheck(wcheck(ii)+1)-par(ii):ycheck(wcheck(ii)+1)-1) tmotion(ycheck(wcheck(ii+1))+1:ycheck(wcheck(ii+1))+par(ii))];
      tcheck=[tmotion(ycheck(wcheck(ii)+1)-par(ii):ycheck(wcheck(ii+1))+par(ii))];
      scheck=spline(ucheck,vcheck,tcheck);
      accz(ycheck(wcheck(ii)+1)-par(ii):ycheck(wcheck(ii+1))+par(ii))=scheck;
      %figure(ii);plot(tmotion(ycheck(wcheck(ii)+1)-par(ii):ycheck(wcheck(ii+1))+par(ii)),accz(ycheck(wcheck(ii)+1)-par(ii):ycheck(wcheck(ii+1))+par(ii)),'o',ucheck,vcheck,tcheck,scheck,'.');
   end;
   
   if length(wcheck)>2,
      vcheck=[accz(ycheck(wcheck(length(wcheck))+1)-par(length(par)):ycheck(wcheck(length(wcheck))+1)-1) accz(ycheck(length(ycheck))+1:ycheck(length(ycheck))+par(length(par)))];
      ucheck=[tmotion(ycheck(wcheck(length(wcheck))+1)-par(length(par)):ycheck(wcheck(length(wcheck))+1)-1) tmotion(ycheck(length(ycheck))+1:ycheck(length(ycheck))+par(length(par)))];
      tcheck=[tmotion(ycheck(wcheck(length(wcheck))+1)-par(length(par)):ycheck(length(ycheck))+par(length(par)))];
      scheck=spline(ucheck,vcheck,tcheck);
      accz(ycheck(wcheck(length(wcheck))+1)-par(length(par)):ycheck(length(ycheck))+par(length(par)))=scheck;
      %figure(length(wcheck));plot(tmotion(ycheck(wcheck(length(wcheck))+1)-par(length(par)):ycheck(length(ycheck))+par(length(par))),accz(ycheck(wcheck(length(wcheck))+1)-par(length(par)):ycheck(length(ycheck))+par(length(par))),'o',ucheck,vcheck,tcheck,scheck,'.');
   end;
   if length(wcheck)==2 & length(ycheck)~=wcheck(2),
      vcheck=[accz(ycheck(wcheck(2)+1)-par(2):ycheck(wcheck(2)+1)-1) accz(ycheck(length(ycheck))+1:ycheck(length(ycheck))+par(2))];
      ucheck=[tmotion(ycheck(wcheck(2)+1)-par(2):ycheck(wcheck(2)+1)-1) tmotion(ycheck(length(ycheck))+1:ycheck(length(ycheck))+par(2))];
      tcheck=[tmotion(ycheck(wcheck(2)+1)-par(2):ycheck(length(ycheck))+par(2))];
      scheck=spline(ucheck,vcheck,tcheck);
      accz(ycheck(wcheck(2)+1)-par(2):ycheck(length(ycheck))+par(2))=scheck;
      %figure(2);plot(tmotion(ycheck(wcheck(2)+1)-par(2):ycheck(length(ycheck))+par(2)),accz(ycheck(wcheck(2)+1)-par(2):ycheck(length(ycheck))+par(2)),'o',ucheck,vcheck,tcheck,scheck,'.');
   end;
end;
clear vcheck ucheck tcheck scheck xcheck ycheck wcheck z

accx=accx';
accy=accy';
ratex=ratex';
ratey=ratey';
ratez=ratez';

if clearit
clear headr dfx2 dfx1 dfl G Filtn Cax Cax1 Cay Cay1 Caz Caz1 Crx Crx1 Cry Cry1 
clear Crz Crz1 FF ans ii %tmotion
end;

fclose(flist);

% if length(accx)<72000,
%    accx=[accx (1:(72000-length(accx))).*0+accx(length(accx))];
% end;
% if length(accy)<72000,
%    accy=[accy (1:(72000-length(accy))).*0+accy(length(accy))];
% end;
% if length(accz)<72000,
%    accz=[accz (1:(72000-length(accz))).*0+accz(length(accz))];
% end;
% if length(ratex)<72000,
%    ratex=[ratex (1:(72000-length(ratex))).*0+ratex(length(ratex))];
% end;
% if length(ratey)<72000,
%    ratey=[ratey (1:(72000-length(ratey))).*0+ratey(length(ratey))];
% end;
% if length(ratez)<72000,
%    ratez=[ratez (1:(72000-length(ratez))).*0+ratez(length(ratez))];
% end;
% if length(tmotion)<72000,
%    tmotion=[tmotion (1:(72000-length(tmotion))).*0+tmotion(length(tmotion))];
% end;
% 
% if length(accx)>72000,
%    accx=accx(1:72000);
% end;
% if length(accy)>72000,
%    accy=accy(1:72000);
% end;
% if length(accz)>72000,
%    accz=accz(1:72000);
% end;
% if length(ratex)>72000,
%    ratex=ratex(1:72000);
% end;
% if length(ratey)>72000,
%    ratey=ratey(1:72000);
% end;
% if length(ratez)>72000,
%    ratez=ratez(1:72000);
% end;
% if length(tmotion)>72000,
%    tmotion=tmotion(1:72000);
% end;

% Lenmotion=36000;
% %interpolation at 10Hz
% saccx=interpft(accx,Lenmotion);ii=find(~isnan(saccx));msaccx=mean(saccx(ii));ii=find(isnan(saccx));saccx(ii)=msaccx;   
% saccy=interpft(accy,Lenmotion);ii=find(~isnan(saccy));msaccy=mean(saccy(ii));ii=find(isnan(saccy));saccy(ii)=msaccy;
% saccz=interpft(accz,Lenmotion);ii=find(~isnan(saccz));msaccz=mean(saccz(ii));ii=find(isnan(saccz));saccz(ii)=msaccz;
% sratex=interpft(ratex,Lenmotion);ii=find(~isnan(sratex));msratex=mean(sratex(ii));ii=find(isnan(sratex));sratex(ii)=msratex;   
% sratey=interpft(ratey,Lenmotion);ii=find(~isnan(sratey));msratey=mean(sratey(ii));ii=find(isnan(sratey));sratey(ii)=msratey;
% sratez=interpft(ratez,Lenmotion);ii=find(~isnan(sratez));msratez=mean(sratez(ii));ii=find(isnan(sratez));sratez(ii)=msratez;
% 
% tmotion=0:1/10:35999/10;tmotion=tmotion';
% 
% accx=saccx;
% accy=saccy;
% accz=saccz;
% ratex=sratex;
% ratey=sratey;
% ratez=sratez;

% jl=1:2:71999;
% jj=jl+1;
% for j=1:36000
%    accxm(j)=median(accx(jl(j):jj(j)));
%    accym(j)=median(accy(jl(j):jj(j)));
%    acczm(j)=median(accz(jl(j):jj(j)));
%    ratexm(j)=median(ratex(jl(j):jj(j)));
%    rateym(j)=median(ratey(jl(j):jj(j)));
%    ratezm(j)=median(ratez(jl(j):jj(j)));
% end;

clear mm


%disp('pause');pause
