function y=solco2(x)
%solubility and Schmidt number as function of temperature for CO2
%from Wannikhoff 1992
%x=water temperature in C
%sol=solubility in mole/m^3/atm
%al=dimensionless solubility
%sc=schmidt number
r1=8.314;
a=[-60.2409 93.4157 23.3585];
b=[ 0.023517 -0.023656 0.0047036];
a0=[2073.1 125.62 3.6276 0.043219];
tsx=(x+273.16)/100;
s=a(1)+a(2)./tsx+a(3).*log(tsx)+35*(b(1)+b(2)*tsx+b(3).*tsx.*tsx);
sol=exp(s)*1000;%
al=sol/1e5.*r1.*tsx*100;
sc=a0(1)-a0(2).*x+a0(3).*x.^2-a0(4).*x.^3;
y=[sol al sc];


